package org.apache.fulcrum.security.torque.om;

import java.io.Serializable;
import java.sql.Connection;
import java.util.Objects;

import org.apache.torque.TorqueException;
import org.apache.torque.map.TableMap;
import org.apache.torque.om.ComboKey;
import org.apache.torque.om.NumberKey;
import org.apache.torque.om.ObjectKey;
import org.apache.torque.om.SimpleKey;
import org.apache.torque.om.Persistent;
import org.apache.torque.util.TorqueConnection;
import org.apache.torque.util.Transaction;

/**
 * This class was autogenerated by Torque on:
 *
 * [Thu Nov 04 10:24:00 CET 2021]
 *
 * You should not use this class directly.  It should not even be
 * extended; all references should be to TorqueTurbineRolePermission
 */
@SuppressWarnings("unused")
public abstract class BaseTorqueTurbineRolePermission 
    implements Persistent, Serializable
{
    /** Serial version */
    private static final long serialVersionUID = 1636017840947L;



    /** Defines the roleId field. */
    private Integer roleId = null;

    /** Defines the permissionId field. */
    private Integer permissionId = null;

    /** Whether this object was modified after loading or after last save. */
    private boolean modified = true;

    /** 
     * Whether this object was loaded from the database or already saved 
     * (false) or whether it is not yet in the database(true).
     */
    private boolean isNew = true;

    /** Flag which indicates whether this object is currently saving. */
    private boolean saving = false;

    /** 
     * Flag which indicates whether this object is currently loaded
     * from the database. 
     */
    private boolean loading = false;

    /** 
     * Flag which indicates whether this object was deleted from the database.
     * Note that this flags does not always display the current database state,
     * there is no magical connection between this flag and the database.
     */
    private boolean deleted = false;

    /** Defines the aTorqueTurbineRole field. */
    private TorqueTurbineRole aTorqueTurbineRole = null;

    /** Defines the aTorqueTurbinePermission field. */
    private TorqueTurbinePermission aTorqueTurbinePermission = null;





    /**
     * Get the value of roleId.
     *
     * @return the value of roleId as Integer
     */
    public Integer getRoleId() 
    {
        
        return roleId;
    }

    /**
     * Set the value of roleId.
     *
     * @param v new value of roleId
     */
    public void setRoleId(Integer v)
    {
        if (!Objects.equals(this.roleId, v))
        {
            setModified(true);
        }

        this.roleId = v;
        if (aTorqueTurbineRole != null && !Objects.equals(aTorqueTurbineRole.getEntityId(), v))
        {
            aTorqueTurbineRole = null;
        }


    }
    
    /**
     * Get the value of permissionId.
     *
     * @return the value of permissionId as Integer
     */
    public Integer getPermissionId() 
    {
        
        return permissionId;
    }

    /**
     * Set the value of permissionId.
     *
     * @param v new value of permissionId
     */
    public void setPermissionId(Integer v)
    {
        if (!Objects.equals(this.permissionId, v))
        {
            setModified(true);
        }

        this.permissionId = v;
        if (aTorqueTurbinePermission != null && !Objects.equals(aTorqueTurbinePermission.getEntityId(), v))
        {
            aTorqueTurbinePermission = null;
        }


    }
    

    /**
     * Returns whether the object has ever been saved.  This will
     * be false, if the object was retrieved from storage or was created
     * and then saved.
     *
     * @return true, if the object has never been persisted.
     */
    public boolean isNew()
    {
        return isNew;
    }

    /**
     * Sets whether the object has ever been saved.
     *
     * @param isNew true if the object has never been saved, false otherwise.
     */
    public void setNew(boolean isNew)
    {
        this.isNew = isNew;
    }

    /**
     * Returns whether the object has been modified.
     *
     * @return True if the object has been modified.
     */
    public boolean isModified()
    {
        return modified;
    }

    /**
     * Sets whether the object has been modified.
     *
     * @param modified true if the object has been modified, false otherwise.
     */
    public void setModified(boolean modified)
    {
        this.modified = modified;
    }

    /**
     * Sets the modified state for the object to be false.
     */
    public void resetModified()
    {
        modified = false;
    }


    /**
     * Returns whether this object is currently saving.
     *
     * @return true if this object is currently saving, false otherwise.
     */
    public boolean isSaving()
    {
        return saving;
    }

    /**
     * Sets whether this object is currently saving.
     *
     * @param saving true if this object is currently saving, false otherwise.
     */
    public void setSaving(boolean saving)
    {
        this.saving = saving;
    }


    /**
     * Returns whether this object is currently being loaded from the database.
     *
     * @return true if this object is currently loading, false otherwise.
     */
    public boolean isLoading()
    {
        return loading;
    }

    /**
     * Sets whether this object is currently being loaded from the database.
     *
     * @param loading true if this object is currently loading, false otherwise.
     */
    public void setLoading(boolean loading)
    {
        this.loading = loading;
    }


    /**
     * Returns whether this object was deleted from the database.
     * Note that this getter does not automatically reflect database state,
     * it will be set to true by Torque if doDelete() was called with this 
     * object. Bulk deletes and deletes via primary key do not change
     * this flag. Also, if doDelete() was called on an object which does
     * not exist in the database, the deleted flag is set to true even if
     * it was not deleted.
     *
     * @return true if this object was deleted, false otherwise.
     */
    public boolean isDeleted()
    {
        return deleted;
    }

    /**
     * Sets whether this object was deleted from the database.
     *
     * @param deleted true if this object was deleted, false otherwise.
     */
    public void setDeleted(boolean deleted)
    {
        this.deleted = deleted;
    }


    /**
     * Returns the associated TorqueTurbineRole object.
     * If it was not retrieved before, the object is retrieved from
     * the database
     *
     * @return the associated TorqueTurbineRole object
     * @throws TorqueException when reading from the database fails.
     */
    public TorqueTurbineRole getTorqueTurbineRole()
        throws TorqueException
    {
        if (aTorqueTurbineRole == null && !Objects.equals(this.roleId, null))
        {
            aTorqueTurbineRole = org.apache.fulcrum.security.torque.om.TorqueTurbineRolePeer.retrieveByPK(SimpleKey.keyFor(this.roleId));
        }
        return aTorqueTurbineRole;
    }

    /**
     * Return the associated TorqueTurbineRole object
     * If it was not retrieved before, the object is retrieved from
     * the database using the passed connection
     *
     * @param connection the connection used to retrieve the associated object
     *        from the database, if it was not retrieved before
     * @return the associated TorqueTurbineRole object
     * @throws TorqueException If a problem occurs with the get[TorqueTurbineRole] method.
     */
    public TorqueTurbineRole getTorqueTurbineRole(Connection connection)
        throws TorqueException
    {
        if (aTorqueTurbineRole == null && !Objects.equals(this.roleId, null))
        {
            aTorqueTurbineRole = org.apache.fulcrum.security.torque.om.TorqueTurbineRolePeer.retrieveByPK(SimpleKey.keyFor(this.roleId), connection);
        }
        return aTorqueTurbineRole;
    }


    /**
     * Declares an association between this object and a TorqueTurbineRole object
     *
     * @param v TorqueTurbineRole
     */
    public void setTorqueTurbineRole(TorqueTurbineRole v)
    {
        if (v == null)
        {
            setRoleId(null);
        }
        else
        {
            setRoleId(v.getEntityId());
        }
        aTorqueTurbineRole = v;
    }
    /**
     * Provides convenient way to set a relationship based on a
     * ObjectKey, for example
     * <code>bar.setFooKey(foo.getPrimaryKey())</code>
     *
     * @param key the key to set
     * @throws TorqueException if associated objects are not found
     */
    public void setTorqueTurbineRoleKey(ObjectKey<?> key) throws TorqueException
    {
       
        setRoleId(Integer.valueOf(((NumberKey) key).intValue()));
     }

    /**
     * Returns the associated TorqueTurbinePermission object.
     * If it was not retrieved before, the object is retrieved from
     * the database
     *
     * @return the associated TorqueTurbinePermission object
     * @throws TorqueException when reading from the database fails.
     */
    public TorqueTurbinePermission getTorqueTurbinePermission()
        throws TorqueException
    {
        if (aTorqueTurbinePermission == null && !Objects.equals(this.permissionId, null))
        {
            aTorqueTurbinePermission = org.apache.fulcrum.security.torque.om.TorqueTurbinePermissionPeer.retrieveByPK(SimpleKey.keyFor(this.permissionId));
        }
        return aTorqueTurbinePermission;
    }

    /**
     * Return the associated TorqueTurbinePermission object
     * If it was not retrieved before, the object is retrieved from
     * the database using the passed connection
     *
     * @param connection the connection used to retrieve the associated object
     *        from the database, if it was not retrieved before
     * @return the associated TorqueTurbinePermission object
     * @throws TorqueException If a problem occurs with the get[TorqueTurbinePermission] method.
     */
    public TorqueTurbinePermission getTorqueTurbinePermission(Connection connection)
        throws TorqueException
    {
        if (aTorqueTurbinePermission == null && !Objects.equals(this.permissionId, null))
        {
            aTorqueTurbinePermission = org.apache.fulcrum.security.torque.om.TorqueTurbinePermissionPeer.retrieveByPK(SimpleKey.keyFor(this.permissionId), connection);
        }
        return aTorqueTurbinePermission;
    }


    /**
     * Declares an association between this object and a TorqueTurbinePermission object
     *
     * @param v TorqueTurbinePermission
     */
    public void setTorqueTurbinePermission(TorqueTurbinePermission v)
    {
        if (v == null)
        {
            setPermissionId(null);
        }
        else
        {
            setPermissionId(v.getEntityId());
        }
        aTorqueTurbinePermission = v;
    }
    /**
     * Provides convenient way to set a relationship based on a
     * ObjectKey, for example
     * <code>bar.setFooKey(foo.getPrimaryKey())</code>
     *
     * @param key the key to set
     * @throws TorqueException if associated objects are not found
     */
    public void setTorqueTurbinePermissionKey(ObjectKey<?> key) throws TorqueException
    {
       
        setPermissionId(Integer.valueOf(((NumberKey) key).intValue()));
     }







    /**
     * Stores an object in the database.  If the object is new,
     * it is inserted; otherwise an update is performed.
     *
     * @throws TorqueException if an error occurs during saving.
     */
    public void save() throws TorqueException
    {
        save(TorqueTurbineRolePermissionPeer.DATABASE_NAME);
    }

    /**
     * Stores an object in the database.  If the object is new,
     * it is inserted; otherwise an update is performed.
     *
     * @param dbName the name of the database to which the object
     *        should be saved.
     *
     * @throws TorqueException if an error occurs during saving.
     */
    public void save(String dbName) 
            throws TorqueException
    {
        try (TorqueConnection con = Transaction.begin(dbName))
        {
            save(con);
            Transaction.commit(con);
        }
    }

    /**
     * Stores an object in the database.  If the object is new,
     * it is inserted; otherwise an update is performed.  This method
     * is meant to be used as part of a transaction, otherwise use
     * the save() method and the connection details will be handled
     * internally.
     *
     * @param con the connection to use for saving the object, not null.
     *
     * @throws TorqueException if an error occurs during saving.
     */
    public void save(Connection con) 
            throws TorqueException
    {
        if (isSaving())
        {
            return;
        }
        try
        {
            setSaving(true);
            // If this object has been modified, then save it to the database.
            if (isModified())
            {
                if (isNew())
                {
                    TorqueTurbineRolePermissionPeer.doInsert((TorqueTurbineRolePermission) this, con);
                    setNew(false);
                }
                else
                {
                    TorqueTurbineRolePermissionPeer.doUpdate((TorqueTurbineRolePermission) this, con);
                }
            }

        }
        finally
        {
            setSaving(false);
        }
    }





    private final SimpleKey<?>[] pks = new SimpleKey[2];
    private final ComboKey comboPK = new ComboKey(pks);

    /**
     * Set the PrimaryKey with an ObjectKey
     *
     * @param key the primary key to set, not null.
     */
    public void setPrimaryKey(ObjectKey<?> key) throws TorqueException
    {
        SimpleKey<?>[] keys = (SimpleKey[]) key.getValue();
        setRoleId(((NumberKey) keys[0]).intValue());
        setPermissionId(((NumberKey) keys[1]).intValue());
    }

    /**
     * Set the PrimaryKey using SimpleKeys.
     *
     * @param roleId a part of the primary key.
     * @param permissionId a part of the primary key.
     */
    public void setPrimaryKey(Integer roleId, Integer permissionId)
        
    {
        setRoleId(roleId);
        setPermissionId(permissionId);
    }

    /**
     * Set the PrimaryKey using a String.
     * @param key the primary key to set.
     */
    public void setPrimaryKey(String key) throws TorqueException
    {
        setPrimaryKey(new ComboKey(key));
    }

    /**
     * returns an id that differentiates this object from others
     * of its class.
     */
    public ObjectKey<?> getPrimaryKey()
    {
        SimpleKey<?>[] pks = new SimpleKey[2];
        pks[0] = SimpleKey.keyFor(getRoleId());
        pks[1] = SimpleKey.keyFor(getPermissionId());
        return new ComboKey(pks);
    }


    /**
     * Returns an id that differentiates the referenced TorqueTurbineRole object
     * from all other TorqueTurbineRole objects.
     *
     * @return an ObjectKey.
     */
    public ObjectKey<?> getForeignKeyForTorqueTurbineRole()
    {
        return SimpleKey.keyFor(getRoleId());
    }
    /**
     * Returns an id that differentiates the referenced TorqueTurbinePermission object
     * from all other TorqueTurbinePermission objects.
     *
     * @return an ObjectKey.
     */
    public ObjectKey<?> getForeignKeyForTorqueTurbinePermission()
    {
        return SimpleKey.keyFor(getPermissionId());
    }

    /**
     * Makes a copy of this object.
     * It creates a new object filling in the simple attributes.
     * It then fills all the association collections and sets the
     * related objects to isNew=true.
     * @throws TorqueException if retrieval of the associated objects fails  
     */
    public TorqueTurbineRolePermission copy() throws TorqueException
    {
        return copy(true);
    }

    /**
     * Makes a copy of this object using a connection.
     * It creates a new object filling in the simple attributes.
     * It then fills all the association collections and sets the
     * related objects to isNew=true.
     *
     * @param con the database connection to read associated objects.
     * @throws TorqueException if retrieval of the associated objects fails     
     */
    public TorqueTurbineRolePermission copy(Connection con) throws TorqueException
    {
        return copy(true, con);
    }

    /**
     * Makes a copy of this object.
     * It creates a new object filling in the simple attributes.
     * If the parameter deepcopy is true, it then fills all the
     * association collections and sets the related objects to
     * isNew=true.
     *
     * @param deepcopy whether to copy the associated objects.
     * @throws TorqueException if retrieval of the associated objects fails
     */
    public TorqueTurbineRolePermission copy(boolean deepcopy) throws TorqueException
    {
        TorqueTurbineRolePermission torqueTurbineRolePermission = new TorqueTurbineRolePermission();

        return copyInto(torqueTurbineRolePermission, deepcopy);
    }

    /**
     * Makes a copy of this object using connection.
     * It creates a new object filling in the simple attributes.
     * If the parameter deepcopy is true, it then fills all the
     * association collections and sets the related objects to
     * isNew=true.
     *
     * @param deepcopy whether to copy the associated objects.
     * @param con the database connection to read associated objects.
     * @throws TorqueException if retrieval of the associated objects fails
     */
    public TorqueTurbineRolePermission copy(boolean deepcopy, Connection con) throws TorqueException
    {
        TorqueTurbineRolePermission torqueTurbineRolePermission = new TorqueTurbineRolePermission();

        return copyInto(torqueTurbineRolePermission, deepcopy, con);
    }
  
    /**
     * Fills the copyObj with the contents of this object.
     * The associated objects are also copied and treated as new objects.
     *
     * @param copyObj the object to fill.
     * @throws TorqueException if retrieval of the associated objects fails
     */
    public TorqueTurbineRolePermission copyInto(TorqueTurbineRolePermission copyObj) throws TorqueException
    {
        return copyInto(copyObj, true);
    }

    /**
     * Fills the copyObj with the contents of this object using connection.
     * The associated objects are also copied and treated as new objects.
     *
     * @param copyObj the object to fill.
     * @param con the database connection to read associated objects.
     * @throws TorqueException if retrieval of the associated objects fails
     */
    public TorqueTurbineRolePermission copyInto(TorqueTurbineRolePermission copyObj, Connection con) throws TorqueException
    {
        return copyInto(copyObj, true, con);
    }
  
    /**
     * Fills the copyObj with the contents of this object.
     * If deepcopy is true, The associated objects are also copied
     * and treated as new objects.
     *
     * @param copyObj the object to fill.
     * @param deepcopy whether the associated objects should be copied.
     * @throws TorqueException if retrieval of the associated objects fails
     */
    protected TorqueTurbineRolePermission copyInto(TorqueTurbineRolePermission copyObj, boolean deepcopy) throws TorqueException
    {
        copyObj.setRoleId((Integer) null);
        copyObj.setPermissionId((Integer) null);

        if (deepcopy)
        {
        }
        return copyObj;
    }
        
    
    /**
     * Fills the copyObj with the contents of this object using connection.
     * If deepcopy is true, The associated objects are also copied
     * and treated as new objects.
     *
     * @param copyObj the object to fill.
     * @param deepcopy whether the associated objects should be copied.
     * @param con the database connection to read associated objects.
     * @throws TorqueException if retrieval of the associated objects fails
     */
    public TorqueTurbineRolePermission copyInto(TorqueTurbineRolePermission copyObj, boolean deepcopy, Connection con) throws TorqueException
    {
        copyObj.setRoleId((Integer) null);
        copyObj.setPermissionId((Integer) null);

        if (deepcopy)
        {
        }
        return copyObj;
    }

    /** The Peer class */
    private static final org.apache.fulcrum.security.torque.om.TorqueTurbineRolePermissionPeer peer
            = new org.apache.fulcrum.security.torque.om.TorqueTurbineRolePermissionPeer();

    /**
     * returns a peer instance associated with this om.  Since Peer classes
     * are not to have any instance attributes, this method returns the
     * same instance for all member of this class. The method could therefore
     * be static, but this would prevent one from overriding the behavior.
     */
    public org.apache.fulcrum.security.torque.om.TorqueTurbineRolePermissionPeer getPeer()
    {
        return peer;
    }

    /**
     * Retrieves the TableMap object related to this Table data without
     * compiler warnings of using getPeer().getTableMap().
     *
     * @return The associated TableMap object.
     * @throws TorqueException if associated objects are not found
     */
    public TableMap getTableMap() throws TorqueException
    {
        return org.apache.fulcrum.security.torque.om.TorqueTurbineRolePermissionPeer.getTableMap();
    }



    public String toString()
    {
        StringBuffer str = new StringBuffer();
        str.append("TorqueTurbineRolePermission:\n");
        str.append("roleId = ")
           .append(getRoleId())
           .append("\n");
        str.append("permissionId = ")
           .append(getPermissionId())
           .append("\n");
        return(str.toString());
    }

    /**
     * Compares the primary key of this instance with the key of another.
     *
     * @param toCompare The object to compare to.
     * @return Whether the primary keys are equal and the object have the
     *         same class.
     */
    public boolean equals(Object toCompare)
    {
        if (toCompare == null)
        {
            return false;
        }
        if (this == toCompare)
        {
            return true;
        }
        if (!getClass().equals(toCompare.getClass()))
        {
            return false;
        }
        TorqueTurbineRolePermission other = (TorqueTurbineRolePermission) toCompare;
        if (getPrimaryKey() == null || other.getPrimaryKey() == null)
        {
            return false;
        }
        return getPrimaryKey().equals(other.getPrimaryKey());
    }

    /**
     * If the primary key is not <code>null</code>, return the hashcode of the
     * primary key.  Otherwise calls <code>Object.hashCode()</code>.
     *
     * @return an <code>int</code> value
     */
    public int hashCode()
    {
        ObjectKey<?> ok = getPrimaryKey();
        if (ok == null)
        {
            return super.hashCode();
        }

        return ok.hashCode();
    }



    /**
     * Compares the content of this object to another object
     *
     * @param toCompare The object to compare to.
     * @return true if all of the columns in the other object have 
     *         the same value as the objects in this class.
     */
    public boolean valueEquals(TorqueTurbineRolePermission toCompare)
    {
        if (toCompare == null)
        {
            return false;
        }
        if (this == toCompare)
        {
            return true;
        }
        if (!Objects.equals(this.roleId, toCompare.getRoleId()))
        {
            return false;
        }
        if (!Objects.equals(this.permissionId, toCompare.getPermissionId()))
        {
            return false;
        }
        return true;
    }



}
